package objectes;
import java.util.Iterator;
import java.util.LinkedList;



import operacions.Operador;

import precondicions.Precondicio;

public class pila {
 private LinkedList<Object> pila;
 //private Vector<Precondicio> pila;
 
public pila() {
 this.pila= new LinkedList();	
}

public void add(Object x){
	pila.addFirst(x);
}

public boolean buida(){
	return pila.isEmpty();
}

public void llistar (){
	Object c = null;
	Iterator it = pila.iterator();
	while (it.hasNext()) {
		c = it.next();
		if (c instanceof Precondicio){
		System.out.println(((Precondicio) c).getNom()+ "(" + ((Precondicio) c).getX() + "," + ((Precondicio) c).getY() + ")");
		}
		if (c instanceof Operador){
			System.out.println(((Operador) c).getNom()+ "(" + ((Operador) c).getX() + "," + ((Operador) c).getY() + ")");
			}
		}
	}

public Object desapila() {
	Object i=pila.getFirst();
	pila.removeFirst();
	return i;
}

public void eliminar (Precondicio pi) {
	Object u;
	boolean trobat=false;
	Iterator it = pila.iterator();
	//u = it.next();
	while ((it.hasNext()) && !trobat) {
		    u = it.next();
			if ((pi.getNom().equals(((Precondicio)u).getNom())) && (pi.getY()==((Precondicio)u).getY()) && (((Precondicio)u).getX()==pi.getX())){
			pila.remove(u);
			trobat=true;
			}		
	}
}

public Object primer() {
	Object i=pila.getFirst();
	return i;
}


public boolean secumple (Precondicio pi) {
	
	System.out.println("Precondicio: "+((Precondicio) pi).getNom()+ "(" + ((Precondicio) pi).getX() + "," + ((Precondicio) pi).getY() + ")");	
	boolean trobat = false;
	Precondicio u=null;
	Iterator it = pila.iterator();
	while ((it.hasNext()) && !trobat) {
		u = (Precondicio)it.next();
		System.out.println("Iterador: "+((Precondicio) u).getNom()+ "(" + ((Precondicio) u).getX() + "," + ((Precondicio) u).getY() + ")");
		
		if (pi.getNom()!="brazolibre"){
		if (u.getNom().equals(pi.getNom()) && u.getX()==pi.getX() && u.getY()==pi.getY()){
			trobat=true;
		}
		}else{
			if (u.getNom().equals(pi.getNom())){
				trobat=true;
			}
		}
	}
	return trobat;
}

public char buscarquehihasobre(Operador i){
	boolean trobat = false;
	Operador u=null;
	Iterator it = pila.iterator();
	while ((it.hasNext()) && !trobat) {
		u = (Operador)it.next();
		if ((i.getNom().equals(u.getNom())) && (i.getY()==u.getY()) && u.getX()!=' '){
			trobat=true;
		}
	}
	return u.getX();
}

public char damunt(char y) {
	boolean trobat = false;
	Object u;
	Iterator it = pila.iterator();
	while ((it.hasNext()) && !trobat) {
		u =it.next();
		if (u instanceof Precondicio){
			
		if ((((Precondicio)u).getNom().equals("sobre")) && (((Precondicio)u).getY()==y)){
			return ((Precondicio)u).getX();
		}
		}
	}
	return ' ';
}

//metode que ens instancia totes les precondicions fins trobar un operador
public void instanciarfinsop(char x) {
	boolean trobat = false;
	Object u;
	Iterator it = pila.iterator();
	while ((it.hasNext()) && !trobat) {
		u =it.next();
		if (u instanceof Precondicio){
			
		if (((Precondicio)u).getX()==' ' && !((Precondicio)u).getNom().equals("brazolibre")){
			((Precondicio)u).setX(x);
		}
		}
		//si es un operador l'instanciem i sortim!!
		if (u instanceof Operador){
		if (((Operador)u).getX()==' '){
			((Operador)u).setX(x);
		}
		trobat=true;
		}
		
		if (u instanceof pila){	
			((pila)u).instanciarfinsopi(x);
		}
		
		
		
	}
}

public void instanciarfinsopi(char x) {
	boolean trobat = false;
	Object u;
	Iterator it = pila.iterator();
	while ((it.hasNext())) {
		u =it.next();
		if (u instanceof Precondicio){
			
		if (((Precondicio)u).getX()==' ' && !((Precondicio)u).getNom().equals("brazolibre")){
			((Precondicio)u).setX(x);
		}
		}		
	}
}

public char agafat(pila estado) {
	boolean trobat = false;
	Precondicio u=null;
	Iterator it = pila.iterator();
	while ((it.hasNext()) && !trobat) {
		u = (Precondicio)it.next();
		if (u.getNom().equals("cogido")){
			trobat=true;
		}
	}
	return u.getX();
}

//metode que ens busca sobre quin bloc s'ha d'apilar el que es te agafat
public char sota(char o) {
	boolean trobat = false;
	Precondicio u=null;
	Iterator it = pila.iterator();
	while ((it.hasNext()) && !trobat) {
		u = (Precondicio)it.next();
		if (u.getNom().equals("sobre")&& (u.getX()==o)){
			trobat=true;
		}
	}
	return u.getY();
}


public Iterator<Object> iterator(){
	return (pila.iterator());
}


//metode que donada una llista mira si es cumpleixen totes les condicions
public boolean mirar_condicions(Object i) {
	boolean trobat = true;
	Precondicio u=null;
	Iterator iti = ((pila)i).iterator();
	while (iti.hasNext()) {
	u = (Precondicio)iti.next();
		if (secumple(u)==false){
			pila.add(u);
			trobat=false;
		}
	}
	return(trobat);
}



}
