package operacions;

import objectes.pila;
import precondicions.Precondicio;

public class Operador {
	private String nom;
	private char X,Y;
	
	public Operador(String nom, char x, char y) {
		this.nom = nom;
		X = x;
		Y = y;
	}

	public String getNom() {
		return nom;
	}

	public int aplicar_operador(pila x,int ncols) {
		if (nom.equals("coger")){
			//eliminamos
			x.eliminar(new Precondicio ("brazolibre",' ',' ','S'));
			x.eliminar(new Precondicio ("sobretaula",X,' ',' '));
			//aadimos esto
			x.add(new Precondicio("cogido",X,' ',' '));
			ncols--;
		}
		if (nom.equals("dejar")){
			//eliminamos
			x.eliminar(new Precondicio("cogido",X,' ',' '));
			//aadimos
			x.add(new Precondicio ("sobretaula",X,' ',' '));
			x.add(new Precondicio ("brazolibre",' ',' ','S'));
			ncols++;
		}
		if (nom.equals("desapilar")){
			//eliminamos
			x.eliminar(new Precondicio ("brazolibre",' ',' ','S'));
			x.eliminar(new Precondicio ("sobre",X,Y,' '));
			//aadimos
			x.add(new Precondicio("cogido",X,' ',' '));
			x.add(new Precondicio("lliure",Y,' ',' '));
		}
		if (nom.equals("apilar")){
			//eliminamos
			x.eliminar(new Precondicio("cogido",X,' ',' '));
			x.eliminar(new Precondicio("lliure",Y,' ',' '));
			//aadimos
			x.add(new Precondicio ("sobre",X,Y,' '));
			x.add(new Precondicio ("brazolibre",' ',' ','S'));
		}
		return (ncols);
	}

	public char getX() {
		return X;
	}

	public char getY() {
		return Y;
	}

	//Funcio que ens afegeix precondicions de les operacions
	public void apilar_precondicions(pila p) {	
		
		pila llista_p=new pila();
		
		if (nom.equals("coger")){
			llista_p.add(new Precondicio("sobretaula",X,' ',' '));
			llista_p.add(new Precondicio("brazolibre",' ',' ','S'));
			llista_p.add(new Precondicio("lliure",X,' ',' '));
			p.add(llista_p);
			//precondicions
			p.add(new Precondicio("brazolibre",' ',' ','S'));
			p.add(new Precondicio("sobretaula",X,' ',' '));
			
			p.add(new Precondicio("lliure",X,' ',' '));
			
		}
		
		if (nom.equals("dejar")){
			llista_p.add(new Precondicio("cogido",X,' ',' '));
			p.add(llista_p);
			//precondicions
			p.add(new Precondicio("cogido",X,' ',' '));	
		}
		
		if (nom.equals("desapilar")){
			llista_p.add(new Precondicio("brazolibre",' ',' ','S'));
			llista_p.add(new Precondicio("lliure",X,' ',' '));
			llista_p.add(new Precondicio("sobre",X,Y,' '));
			p.add(llista_p);
			//precondicions
			p.add(new Precondicio("brazolibre",' ',' ','S'));
			p.add(new Precondicio("lliure",X,' ',' '));
			p.add(new Precondicio("sobre",X,Y,' '));
					
		}
		
		if (nom.equals("apilar")){
			llista_p.add(new Precondicio("cogido",X,' ',' '));
			llista_p.add(new Precondicio("lliure",Y,' ',' '));
			p.add(llista_p);
			//precondicions
			p.add(new Precondicio("cogido",X,' ',' '));
			p.add(new Precondicio("lliure",Y,' ',' '));	
		}
		
	}

	public void setX(char x) {
		X = x;
	}

	public void setY(char y) {
		Y = y;
	}
		
}
